#include <cdiv.h>

const
    // Distintos estados de los muecos
    int
    _parado           = 0,
    _avanzando        = 1,
    _retrocediendo    = 2,
    _agachandose      = 3,
    _agachado         = 4,
    _levantandose     = 5,
    _saltando         = 6,
    _golpe_bajo       = 7,
    _punetazo         = 8,
    _patada_giratoria = 9,
    _patada_normal    = 10,
    _patada_aerea     = 11,
    _tocado           = 12,
    _muerto           = 13,

    // Distintas posiciones de los muecos
    saltar     = 0,
    agacharse  = 1,
    avanzar    = 2,
    retroceder = 3,
    golpear    = 4,

    // Tipo de control del mueco
    control_teclado1  = 1,
    control_teclado2  = 2,
    control_ordenador = 0,

    default_fps = 24; // Numero de imgenes por segundo

// Datos globales
    CPROCESS * id_luchador1, * id_luchador2;  // Identificador de ambos combatientes
    CPROCESS * id_auxiliar;                   // Identificador auxiliar    
    // Secuencia de animacin de cada uno de los estados de los muecos
    int
    anim0[]={1,1,1,14,14,15,15,16,16,17,17,17,16,16,15,15,14,14},
    anim1[]={1,2,3,4,5,6,7,8},
    anim2[]={1,8,7,6,5,4,3,2},
    anim3[]={8,9,10,11,12,13},
    anim4[]={13},
    anim5[]={13,12,11,10,9,8},
    anim6[]={18,19,20,21,21,22,22,22,22,23,23,23,23,24,24,24,24,24,24,24,24},
    anim7[]={52,54,54,54,54,53,53,52,51},
    anim8[]={25,26,27,28,28,28,28,27,27,26,25},
    anim9[]={29,30,31,32,33,33,34,35,36,37,38,39},
    anim10[]={29,30,31,32,32,32,31,31,30,30,29},
    anim11[]={18,19,20,21,21,22,22,24,40,41,41,41,41,41,41,41,41,41,41,41,41,41},
    anim12[]={1,42,42,43,43,42,42},
    anim13[]={1,42,42,43,43,44,44,45,45,46,46,47,47,48,48,49,49,50},

    s_golpe1,        // Identificadores de sonidos
    s_golpe2,
    s_golpe3,
    s_tocado1,
    s_tocado2,
    s_tocado3,
    s_aire1,
    s_aire2,
    s_aire3,
    s_aire4,
    s_aire5,
    s_muerto,

    combates1,      // Numero de combates que ha ganado el primero
    combates2,      // Numero de combates que ha ganado el segundo

    estado_juego,   // 0-parado, 1-jugando, 2-fin combate

    escenario,      // Escenario de lucha 0 / 1

    luchador1 = 1,    // 0-Ripley, 1-Bishop, 2-Alien, 3-Nostromo
    luchador2 = 2,    // 0-Ripley, 1-Bishop, 2-Alien, 3-Nostromo

    nivel = 1,        // Dificultad del juego (0..2)
    modo,             // Modo de juego (ver modos[])
    sangre = 1,       // Nivel de sangre (ver sangres[])
    fpg_game,
    fpg_player1,
    fpg_player2;

    // Textos de las opciones de combate
    
    char 
    nombres[][10]={{"RIPLEY"},{"BISHOP"},{"ALIEN"},{"NOSTROMO"}},
    escenarios[][30]={{"ESCENARIO 1: CASTILLO IKA"},{"ESCENARIO 2: LA CUEVA"},
                      {"ESCENARIO 3: DESIERTO"}},
    niveles[][30]={{"DIFICULTAD : FACIL"},{"DIFICULTAD : NORMAL"},{"DIFICULTAD : DIFICIL"}},
    modos[][40]={{"ORDENADOR contra ORDENADOR"},{" TECLAS CURSOR contra ORDENADOR"},
                 {"TECLAS QA-RT-X contra ORDENADOR"},{"TECLAS QA-RT-X contra TECLAS CURSOR"}},
    sangres[][30]={{"NIVEL DE SANGRE : NINGUNA"},{"NIVEL DE SANGRE : NORMAL"},{"NIVEL DE SANGRE : EXTASIS"}};

    struct _texto // Textos donde se guardan las opciones del combate
    {
        int x,y;
        int codigo;
    };
    
    struct _texto texto[7] = 
         {320,480,0,
          320,90,0,
          320,120,0,
          320,150,0,
          100,364,0,
          320,364,0,
          540,364,0};

    int
    mMenu = 0, mCreditos = 0, mFase = 0,
    opcion,         // Opcin seleccionada del men
    opcion_anterior,

    esc_pulsado,    // Indica si se ha abortado con ESC

    grises[256]=    // Tabla de conversin de los colores a grises
       {0,236,203,220,159,156,155,153,151,150,134,89,90,92,94,94,
        45,46,69,59,103,93,90,134,150,151,155,156,159,220,203,236,
        41,43,46,47,69,59,101,94,40,41,43,43,44,45,46,47,
        40,41,44,45,45,46,47,68,69,58,58,59,58,58,106,101,
        43,45,47,47,47,68,68,68,68,58,59,101,101,101,59,59,
        45,59,101,94,90,90,90,90,90,89,90,90,90,93,94,94,
        69,59,58,106,103,101,101,103,101,101,59,59,94,92,94,93,
        101,94,93,93,94,92,93,89,89,134,134,134,151,150,150,153,
        101,90,89,90,134,134,134,134,134,90,89,134,134,150,150,151,
        103,134,134,134,150,150,150,151,153,153,153,155,156,156,159,159,
        90,89,150,151,153,155,156,219,219,220,223,203,203,203,236,235,
        134,150,150,151,153,153,153,151,155,156,156,159,220,223,236,237,
        134,153,155,156,156,159,219,220,220,201,203,203,201,203,203,236,
        151,155,156,156,219,219,220,159,155,155,159,219,220,219,220,223,
        151,159,153,155,220,220,159,155,223,236,235,235,236,237,238,237,
        155,153,203,223,237,238,247,247,248,247,238,237,235,236,203,220},

    sangre_total,   // Partculas de sangre que se han quedado en el mapa
    angulo_texto;   // Movimiento del texto en las opciones

PROCESS muneco
 INIT muneco ( int _x, int _y, int _file, int _flags, int _tipo_control, int _luchador)
 BEGIN_INIT
  x = _x; y = _y; file = _file; flags = _flags; 
  tipo_control = _tipo_control; luchador = _luchador;
 END_INIT
 
LOCAL
    int
    energia,
    estado,
    paso,
    tipo_control,
    inc_x,
    inc_y;
    muneco * enemigo;

PRIVATE
    int
    luchador,
    nuevo_estado,       // Variable temporal para el estado del mueco
    nuevo_paso,         // Variable temporal para la posicin de la animacin del mueco
    golpe_x, golpe_y,    // Variables para guardar los puntos de control de los golpes
    // Fuerza de cada uno de los golpes
    contador0,          // Contador de uso general
    fuerza_golpe[5],
    suma_fuerza;        // Fuerza variable dependiendo del nivel y del luchador

PROTOTYPE
    
PROCESS golpe 
 INIT golpe( int _x, int _y, int _dano)
 BEGIN_INIT
  x = _x; y = _y; dano = _dano;
 END_INIT
 
 PRIVATE
    int
    dano,
    contador0;  // Contador de uso general
    CPROCESS * id_munecos; // Identificador a los muecos
 
PROTOTYPE



//------------------------------------------------------------------------------
// Proceso sombra
// Maneja la sombra de los muecos
//------------------------------------------------------------------------------

PROCESS sombra INIT sombra() AUTOINIT

BEGIN
    ctype=c_scroll; // Lo pone dentro del scroll
    graph=1;        // Elige el grfico
    priority=-1;    // Le da prioridad baja para que se ejecute despus
    z=1;            // Lo pone por debajo del grfico del mueco
    y=440;          // Inicializa la coordenada vertical
    flags=4;        // Y hace que sea transparente
    LOOP
    {
        x = father->x; // Hace que siga al mueco
        FRAME;
    }
END

//------------------------------------------------------------------------------
// Proceso Polvo
// Pone una nube de polvo cuando el mueco cae del salto
// Entradas: Coordenadas donde ira el grfico
//------------------------------------------------------------------------------

PROCESS polvo 
 INIT polvo( int _x, int _y)
 BEGIN_INIT
  x = _x;
  y = _y;
 END_INIT

BEGIN
    FRAME;
    ctype=c_scroll; // Lo pone dentro del scroll
    flags=4;        // Lo hace transparente
    z=-1;           // Lo pone por delante del mueco
    
    for( graph = 2; graph <= 12; graph++ )// Anima el grfico
     FRAME;
END


//------------------------------------------------------------------------------
// Proceso particula_sangre
// Maneja la sangre que sale cuando se da un golpe
// Entradas: 'x,y'        : Coordenadas desde donde sale la sangre
//           'inc_x,inc_y': Incrementos en el movimiento de la sangre (cada)
//           'cont_tiempo': Contador del tiempo que aparecer la sangre
//------------------------------------------------------------------------------

PROCESS particula_sangre
 INIT particula_sangre( int _x, int _y, int _inc_x, int _inc_y, int _cont_tiempo)
 BEGIN_INIT
  x = _x; y = _y; inc_x = _inc_x; inc_y = _inc_y; cont_tiempo = _cont_tiempo;
 END_INIT
PRIVATE
 int inc_x, inc_y, cont_tiempo;

BEGIN
    ctype=c_scroll;         // Lo pone dentro del scroll
    // Si esta en el modo de mayor sanguinolencia, espera un poco para que no salga toda junta
    if( sangre == 2 )
     FRAME_PERCENT( rand(1,400) ); // Espera un tiempo al azar
     
    graph = rand(50,53);      // Elige uno de los grficos disponibles al azar
    flags = 4;                // La hace transparente
    z = -2;                   // Lo pone por encima de todo
    while( cont_tiempo > 0 )  // Mueve la sangre mientras haya tiempo
    {
        x+=inc_x;           // Realiza los incrementos en las coordenadas
        y+=inc_y;
        inc_y++;            // Hace que cada vez caiga ms rapido
        if( inc_x > 0 )        // Pero a horizontalmente se mueva ms lento
            inc_x--;
            
        if( inc_x < 0 )
            inc_x++;
            
        if( y > 410 )          // Comprueba si ha tocado el suelo
        {
            // Deja sangre pegada al suelo de forma aleatoria
            if( (rand(0,80) == 0) AND (sangre_total < 50) AND (y < 480))
            {
                z=256;          // La pone detrs
                sangre_total++; // Incrementa el contador de sangre
                LOOP
                    FRAME;      // La deja en un bucle para que quede en pantalla
            }
        }
        cont_tiempo--;          // Incrementa el contador de tiempo
        FRAME;
    }
END

//------------------------------------------------------------------------------
// Proceso golpe_sin_sangre
// Pone un grfico alternativo al de la sangre para los modos sin ella
//------------------------------------------------------------------------------

PROCESS golpe_sin_sangre
 INIT golpe_sin_sangre(int _x, int _y)
 BEGIN_INIT
  x = _x;
  y = _y;
 END_INIT

BEGIN
    ctype=c_scroll; // Lo pone dentro del scroll
    z=-2;           // Por delante de otros grficos
    for( graph=60; graph <= 66; graph++ )
        FRAME;      // Anima el grfico
END


//------------------------------------------------------------------------------
// Proceso estrella
// Imprime los grficos de la estrellas
// Entradas: Coordenadas y tipo de grfico de la estrella
//------------------------------------------------------------------------------

PROCESS ESTRELLA
 INIT ESTRELLA( int _x, int _y, int _graph )
 BEGIN_INIT
  x = _x; y = _y; graph = _graph;
 END_INIT

BEGIN
    LOOP
        FRAME;  // Lo imprime
END

//------------------------------------------------------------------------------
// funcin crea_estrellas
// Maneja las estrellas que indican los combates ganados
//------------------------------------------------------------------------------

void crea_estrellas()
{
    // Elimina cualquier estrella que hubiera antes
    signal("ESTRELLA", s_kill);

    // Pon las estrellas del jugador 1
    switch( combates1 )
    {
        // Dependiendo de los combates ganados pone  unas estrellas u otras
        case 0:
            new ESTRELLA(111,84,203);
            new ESTRELLA(143,84,203);
        break;
        case 1:
            new ESTRELLA(111,84,204);
            new ESTRELLA(143,84,203);
        break;
        case 2:
            new ESTRELLA(111,84,204);
            new ESTRELLA(143,84,204);
        break;
    }

    // Pon las estrellas del jugador 2
    switch( combates2 )
    {
        case 0:
            new ESTRELLA(530,84,203);
            new ESTRELLA(498,84,203);
        break;
        case 1:
            new ESTRELLA(530,84,204);
            new ESTRELLA(498,84,203);
        break;
        case 2:
            new ESTRELLA(530,84,204);
            new ESTRELLA(498,84,204);
        break;
    }
}



//------------------------------------------------------------------------------
// Proceso crditos
// Pone la pantalla de crditos
//------------------------------------------------------------------------------

char textos[][40]=
       {{"PROGRAMADORES"},{"ROGELIO FERNANDEZ Y DANIEL NAVARRO"},{""},
        {"GRAFISTAS"},{"JOSE FERNANDEZ"},{"RAFAEL BARRASO"},{""},
        {"SONIDOS"},{"ANTONIO MARCHAL"},{""},
        {"JUGABILIDAD"},{"LUIS F. FERNANDEZ"},{""},
        {"AGRADECIMIENTOS"},{"FERNANDO PEREZ"},
        {"JORGE SANCHEZ"},{"JAVIER CARRION"},{""},
        {"FOSTIATOR"},{"CDIV GAMES"}};

PROCESS creditos INIT creditos() AUTOINIT

PRIVATE
    int codigo_mapa;    // Identificador al fichero de grficos

BEGIN
    clear_screen();
    FRAME;
    // Carga la pantalla de fondo
    codigo_mapa = load_map("fostiato/creditos.map");
    // Y el tipo de letras
    load_fnt("fostiato/creditos.fnt");
    fade_off(65);
    FRAME;
    put_screen(1, codigo_mapa);          // Pone el fondo
    
    for( y = 0; y <= 19; y++)                     // Y escribe los textos
     write(3,320,40+(y*20),4,textos[y]);
     
    fade_on(5);                          // Enciende la pantalla
    FRAME;
    
    scan_code=0;
    while(scan_code == 0)                              // Espera hasta que se pulse una tecla
     FRAME;     
END

//------------------------------------------------------------------------------
// Proceso intro
// Realiza la intro del juego
//------------------------------------------------------------------------------

PROCESS intro INIT intro() AUTOINIT

PRIVATE
    int
    contador0,      // Contador de uso general
    codigo_mapa,    // Identificador para descargar los graficos
    s_intro;        // Identificador del sonido de la intro
BEGIN
    // Para el proceso general para poner este
    signal(father, s_sleep);
    // Hace que la pantalla cambie rapido
    set_fps(100);
    
    codigo_mapa = load_map("fostiato/intro.map");     // Carga la pantalla
    s_intro     = load_wav("fostiato/introhit.wav",0);    // Carga el sonido
    
    fade_off(64);        // Pone la pantalla en blanco
    FRAME;
    
    sound(s_intro,100,256);     // Hace el sonido
    put_screen(1, codigo_mapa); // Pone el fondo de pantalla
    unload_map(codigo_mapa);    // Descarga el grafico
    
    fade_on();                  // Hace que se vea la pantalla (la enciende)
    FRAME;

    // Carga sonidos
    s_golpe1  = load_wav("fostiato/uah00.wav",0);
    s_golpe2  = load_wav("fostiato/whimper2.wav",0);
    s_golpe3  = load_wav("fostiato/whimper3.wav",0);
    s_tocado1 = load_wav("fostiato/hit00.wav",0);
    s_tocado2 = load_wav("fostiato/hit01.wav",0);
    s_tocado3 = load_wav("fostiato/hit02.wav",0);
    s_aire1   = load_wav("fostiato/turn06.wav",0);
    s_aire2   = load_wav("fostiato/turn07.wav",0);
    s_aire3   = load_wav("fostiato/turn08.wav",0);
    s_aire4   = load_wav("fostiato/turn05.wav",0);
    s_aire5   = load_wav("fostiato/turn09.wav",0);
    s_muerto  = load_wav("fostiato/aaah01.wav",0);

    // Carga los graficos y las letras
    fpg_game = load_fpg("fostiato/juego.fpg");
    load_fnt("fostiato/enjuego.fnt");
    load_fnt("fostiato/enjuego2.fnt");
    
    load_pal("fostiato/intro.map");

    // Espera a que se pulse una tecla o pase un tiempo
    while( !key(_esc) AND !key (_space) AND (contador0 < 200) )
    {
        FRAME;
        contador0++;
    }
    
    // Devuelve el control al proceso principal
    signal(father, s_wakeup);
END    

//------------------------------------------------------------------------------
// Proceso objetos
// Pone los grficos estticos del marcador y la pantalla de opciones
// Entradas: fichero grfico, coordenadas, grfico, bandera (der/izq.),
//           zona de la pantalla
//------------------------------------------------------------------------------

PROCESS objetos 
 INIT objetos( int _file, int _x, int _y, int _graph, int _flags, int _region )
 BEGIN_INIT
  file = _file; x = _x; y = _y; graph = _graph; flags = _flags;
  region = _region;
 END_INIT

BEGIN
    z = 10;   // Lo pone por debajo de otros grficos
    LOOP
     FRAME;
END

    
//------------------------------------------------------------------------------
// Funcion muestra_informacion
// Pone los textos y los grficos de la pantalla de opciones
//------------------------------------------------------------------------------

void muestra_informacion()
{
    // Borra todo para luego imprimirlo actualizado
    delete_text(all_text);  // Borra cualquier texto pendiente

    //signal(id_luchador1,s_kill);     // Elimina los procesos de los muecos
    //signal(id_luchador2,s_kill);
    //signal(id_auxiliar ,s_kill);

    // Pone los textos no seleccionables
    write(2,320,0,1,"OPCIONES");
    write(2,320,156,1,"CONTRA");

    // Pone textos seleccionables
    texto[0].codigo = write(2,320,480,7,"EMPEZAR JUEGO");
    texto[1].codigo = write(1,320,90,1,modos[modo]);
    texto[2].codigo = write(1,320,120,1,niveles[nivel]);
    texto[3].codigo = write(1,320,150,1,sangres[sangre]);

    // Pone los grficos de los muecos y del escenario elegidos
    id_luchador1->graph = 310+luchador1;
    id_luchador2->graph = 310+luchador2;
    id_auxiliar->graph  = 300+escenario;

    // Pone los textos de los muecos y del escenario elegido
    texto[4].codigo = write(1,100,364,1,nombres[luchador1]);
    texto[5].codigo = write(1,320,364,1,escenarios[escenario]);
    texto[6].codigo = write(1,540,364,1,nombres[luchador2]);

    // Mueve el texto que esta seleccionado
    move_text(texto[opcion].codigo,
              texto[opcion].x+get_disty(angulo_texto,8),
              texto[opcion].y);
}

//------------------------------------------------------------------------------
// Funcin control
// Mueve los muecos, bien por teclado o controlados por el ordenador
// Entradas: 'accin'   : Accin ha comprobar si se hace
//------------------------------------------------------------------------------

int control( int accion, muneco * father )
{
    int dist;   // Distancia entre los muecos

    // Comprueba que el juego no este en pausa
    if( estado_juego != 1) 
     return 0; 

    // Lee la tecla dependiendo del tipo de control
    switch( father->tipo_control )     // Mira quien maneja el muneco
    {

        case control_teclado1:      // Si se controla con el teclado1
            // Va mirando que accin se quiere hacer
            // Y leyendo las teclas que se usan para ello
            switch(accion)          // Mira que accin se esta comprobando
            {
                case saltar:
                    return(key(_up));   // Devuelve TRUE si esta pulsada la tecla
                break;
                case agacharse:
                    return(key(_down));
                break;
                case avanzar:
                    if (father->flags)   // Dependiendo hacia donde mire
                        return(key(_right));    // Lee una tecla...
                    else
                        return(key(_left));     // O la otra
                break;
                case retroceder:
                    if (father->flags)
                        return(key(_left));
                    else
                        return(key(_right));
                break;
                case golpear:
                    return(key(_l_control) OR key(_r_control));
                break;
            }
        break;
        case control_teclado2:      // Se esta usando el teclado 2
            switch(accion)          // Se comprueba igual que antes.
            {
                case saltar:
                    return(key(_q));
                break;
                case agacharse:
                    return(key(_a));
                break;
                case avanzar:
                    if (father->flags)
                        return(key(_t));
                    else
                        return(key(_r));
                break;
                case retroceder:
                    if (father->flags)
                        return(key(_r));
                    else
                        return(key(_t));
                break;
                case golpear:
                    return(key(_x));
                break;
            }
        break;
        case control_ordenador:         // Lo maneja el ordenador
            dist = abs(id_luchador1->x - id_luchador2->x);      // Halla la distancia entre los muecos
            switch( father->estado )    // Mira que se quiere comprobar
            {
                // Va mirando que accin se quiere hacer
                // Y se comprueba si es conveniente
                case _parado:
                    switch(accion)
                    {
                        case saltar:
                            // Si se esta a distancia correcta y...
                            // da la suerte devuelve TRUE
                            if( (dist < 160) AND (rand(0,35) == 0) )
                                return(1);
                        break;
                        case agacharse: // Igual para las dems acciones
                            if( (dist < 160) AND (rand(0,25) == 0))
                                return(1);
                        break;
                        case avanzar:
                            if( dist > 400 )
                            {
                                if( rand(0,4) == 0 )
                                    return(1);
                            }else{
                                if( (dist > 120) AND (rand(0,8) == 0) )
                                    return(1);
                            }
                        break;
                        case retroceder:
                            if( (dist < 180) AND (rand(0,25) == 0) )
                                return(1);
                            if( (dist < 80) AND (rand(0,5) == 0) )
                                return(1);
                        break;
                        case golpear:
                            if( (dist < 180) AND (dist > 60) AND (rand(0,5) == 0) )
                                return(1);
                        break;
                    }
                break;
                case _avanzando:
                    switch(accion)
                    {
                        case saltar:
                            if( (dist > 180) AND (dist < 300) AND (rand(0,8) == 0) )
                                return(1);
                        break;
                        case golpear:
                            if( dist < 140 )
                                return(1);
                        break;
                    }
                break;
                case _retrocediendo:
                    switch(accion)
                    {
                        case saltar:
                            if( (dist < 120) AND (rand(0,6) == 0) )
                                return(1);
                        break;
                        case golpear:
                            if( (dist > 70) AND (dist < 150) )
                                return(1);
                        break;
                    }
                break;
                case _agachado:
                    switch(accion)
                    {
                        case agacharse:
                            if( rand(0,5) != 0 )
                                return(1);
                        break;
                        case golpear:
                            if( (dist < 180) AND (rand(0,5) == 0) )
                                return(1);
                        break;
                    }
                break;
                case _saltando:
                    switch(accion)
                    {
                        case golpear:
                            if( rand(0,10) == 0 )
                                return(1);
                        break;
                    }
                break;
            }
            // Si la accin es correcta se devuelve 1, si no 0
            return(0);  // No hace ninguna accin
        break;
    }
}

//------------------------------------------------------------------------------
// Proceso mueco
// Maneja todos los tipo de mueco
// Entradas: 'x,y'          : Coordenadas iniciales
//           'file'         : Fichero donde estn los grficos
//           'flags'        : Hacia donde mira el mueco (izq./der.)
//           'tipo_control' : Quien maneja al mueco (teclado1/teclado2/cpu)
//           'luchador'     : Cual es de los dos luchadores
//------------------------------------------------------------------------------

BEGIN_BODY( muneco )
    energia = estado = paso = inc_x = inc_y = 0;
    
    suma_fuerza = nuevo_estado = nuevo_paso = golpe_x = golpe_y = 0;
    
    fuerza_golpe[0] = 35;
    fuerza_golpe[1] = 35;
    fuerza_golpe[2] = 55;
    fuerza_golpe[3] = 35;
    fuerza_golpe[4] = 35;
    
    ctype = c_scroll;     // Lo introduce dentro del scroll
    energia = 203;        // Inicializa la energa
    FRAME;
    new sombra();           // Crea la sombra del mueco

    if( tipo_control != 0 )                        // Si el ordenador no lleva este mueco
    {
        if( enemigo->tipo_control == 0 )            // Pero lleva el del enemigo
            switch(nivel)                       // Dependiendo del nivel de juego (dificultad)
            {
                case 1: suma_fuerza = -10; break;    // Hace que los golpes quiten menos energia
                case 2: suma_fuerza = -18; break;
            }
        else
            suma_fuerza = 10; // Humano vs Humano, iguala las fuerzas
        
    }

    switch(luchador)        // Dependiendo del tipo de luchador
    {
        case 0: suma_fuerza-=8; break; // Ripley pega menos
        case 1: suma_fuerza+=6; break; // Bishop es el segundo que pega ms
        case 2: suma_fuerza+=4; break; // Alien es el segundo que pega menos
        case 3: suma_fuerza+=8; break; // Nostrodomo pega ms que nadie
    }

    // Actualiza la fuerza de los golpes segn los jugadores
    for( contador0 = 0; contador0 <= 4; contador0++ )
     fuerza_golpe[contador0] += suma_fuerza;

    LOOP
    {
        nuevo_estado=estado;    // Actualiza la variable temporal del estado del mueco
        switch(estado)          // Comprueba el estado del mueco
        {
            case _parado:
                graph = anim0[paso];        // Anima el grfico
                paso++;
                
                if( paso == (sizeof(anim0)/4))    // Si no hay mas grficos en la animacin
                    paso = 0;                 // Empieza desde 0
                    
                if (flags)                  // Hace que los muecos se miren
                {
                    if (enemigo->x<x) flags=0;
                }else
                    if (enemigo->x>x) flags=1;
                
                // Comprueba si se quiere cambiar de estado
                if( control(golpear, this) )       // Comprueba si se quiere golpear
                    nuevo_estado = _punetazo; // Y golpea...
                
                if( control(saltar, this) )        // Comprueba si se quiere saltar
                {
                    nuevo_estado = _saltando; // Y salta...
                    inc_y=-16; inc_x=0;     // Inicializa los incrementos para el salto
                }
                if( control(agacharse, this) )     // Comprueba si se quiere agachar
                    nuevo_estado=_agachandose;  // Y se agacha...
                
                if( control(retroceder, this) )    // Comprueba si se quiere retroceder
                    nuevo_estado=_retrocediendo;// Y retrocede...
                
                if( control(avanzar, this) )       // Comprueba si se quiere avanzar
                    nuevo_estado=_avanzando;// Y avanza...
                
            break;

            case _avanzando:                // Si se esta avanzando
                graph = anim1[paso];        // Anima el grfico
                paso++;
                if( paso == (sizeof(anim1)/4))    // Comprueba que no se ha llegado al final de la animacin
                    nuevo_estado=_parado;   // Y si se ha llegado cambia de estado
                
                if (flags)                  // Mueve el mueco segn donde mire
                    x+=4;
                else
                    x-=4;
                
                // Comprueba si se quieren hacer otras acciones
                if( control(golpear, this) )             // Se quiere golpear
                    nuevo_estado=_patada_normal;
                
                if( control(saltar, this) )              // Se quiere saltar
                {
                    nuevo_estado=_saltando;
                    inc_y=-16;
                    if (flags)
                        inc_x=12;
                    else
                        inc_x=-12;
                }
            break;

            case _retrocediendo:            // Mira si se esta retrocediendo
                graph=anim2[paso];        // Anima el grfico
                paso++;
                if( paso == (sizeof(anim2)/4))    // Si se ha llegado al final
                    nuevo_estado=_parado;   // Cambia de estado
                
                if (flags)                  // Lo mueve segn a donde mire
                    x-=4;
                else
                    x+=4;
                
                // Se mira si se quieren hacer otras acciones posibles
                if( control(golpear, this) )
                {
                    nuevo_estado=_patada_giratoria;
                    inc_y=-10;
                }
                if( control(saltar, this) )
                {
                    nuevo_estado=_saltando;
                    inc_y=-16;
                    if (flags)
                        inc_x=-8;
                    else
                        inc_x=8;
                }
            break;

            case _agachandose:  // Comprueba si se esta agachndose
                graph = anim3[paso];        // Haz la animacin
                paso++;
                if( paso == (sizeof(anim3)/4) )    // Hasta que se llegue al final
                    nuevo_estado=_agachado; // Y pasa al estado de agachado
            break;

            case _agachado:         // Comprueba si esta agachado
                graph = anim4[0];     // Pone el grfico necesario
                if (flags)          // Pone al grfico mirando al otro
                {
                    if (enemigo->x < x)
                        flags=0;
                }else
                    if (enemigo->x > x)
                        flags=1;
                // Comprueba si se quiere hacer otras acciones
                if( control(golpear, this) )           // Comprueba si se quiere golpear
                    nuevo_estado = _golpe_bajo;
                if( !control(agacharse, this) )     // Si no quiere agacharse
                    nuevo_estado = _levantandose; // Se pone levantndose
            break;

            case _levantandose:     // Comprueba si esta levantndose
                graph = anim5[paso];        // Anmalo
                paso++;
                if( paso == (sizeof(anim5)/4))    // Si se acabado
                    nuevo_estado=_parado;   // Cambia de estado a parado
            break;

            case _saltando:             // Comprueba si se esta saltando
                graph = anim6[paso];    // Anima los grficos
                paso++;
                if (paso > 0)             // Si se ha llegado al punto de la animacin
                {
                    x+=inc_x;           // Mueve al mueco
                    y+=(inc_y*3);
                    inc_y+=2;           // Cambia el incremento para que bote
                    if(y >= 440)         // Comprueba si ha tocado el suelo
                    {
                        y=440;
                        new polvo(x,y);     // Crea polvo cuando cae
                        // Mira si se quiere saltar otra vez
                        if (control(saltar, this))
                            nuevo_estado=_parado;
                        else
                            nuevo_estado=_agachandose;
                    }
                }
                if (control(golpear, this))       // Comprueba si se quiere golpear
                {
                    nuevo_estado = _patada_aerea;
                    nuevo_paso   = paso;
                }
            break;

            // Comprueba si se esta se hace el golpe bajo
            case _golpe_bajo:
                graph = anim7[paso];        // Anima el grfico
                paso++;
                if( paso == (sizeof(anim7)/4) )    // Si se acaba la animacin
                    nuevo_estado=_agachado; // Se pone en otro estado
                    
                if( flags )                  // Comprueba hacia donde mira
                    x++;                    // Y se mueve un poco
                else
                    x--;
                    
                // Si se ha llegado al punto de la animacin correcto
                if(paso == 2)
                {
                    sound(s_aire1,rand(50,75),256);         // Realiza sonido
                    get_real_point(1,&golpe_x,&golpe_y);    // Coge los puntos de control del puo
                    new golpe(golpe_x,golpe_y,fuerza_golpe[0]); // Y comprueba si se ha tocado
                    if( fuerza_golpe[0] > 2 )  // Reduce la fuerza de golpe
                        fuerza_golpe[0]--;  // para la prxima vez
                }
            break;
            // Comprueba si se esta haciendo la accin puetazo
            case _punetazo:
                graph = anim8[paso];        // Anima el grfico
                paso++;
                if( paso == (sizeof(anim8)/4) )    // Hasta que se acabe la animacin
                    nuevo_estado=_parado;   // Y cambia a un nuevo estado
                    
                if (flags)                  // Comprueba hacia donde mira
                    x++;                    // Y se mueve
                else
                    x--;
                    
                if( paso == 4 )    // Si se ha llegado al punto de la animacin
                {
                    // Realiza el golpe
                    sound(s_aire2,rand(50,75),256);
                    get_real_point(1,&golpe_x,&golpe_y);    // Halla el punto donde se dara el golpe
                    new golpe(golpe_x,golpe_y,fuerza_golpe[1]); // Comprueba si se da el golpe
                    if (fuerza_golpe[1]>2)                  // Quita fuerza al golpe
                        fuerza_golpe[1]--;
                }
            break;

            case _patada_giratoria: // Comprueba la patada giratoria como los anteriores golpes
                graph=anim9[paso];
                paso++;
                if( paso == (sizeof(anim9)/4) )
                    nuevo_estado=_parado;
                
                y+=inc_y; inc_y+=2;
                if( y > 440 )
                    y=440;
                
                if( paso == 5 )
                {
                    sound(s_aire3,rand(50,75),256);
                    get_real_point(1,&golpe_x,&golpe_y);
                    new golpe(golpe_x,golpe_y,fuerza_golpe[2]);
                    if( fuerza_golpe[2] > 2 )
                        fuerza_golpe[2]--;
                }
            break;

            case _patada_normal:    // Comprueba la patada normal
                graph = anim10[paso];
                paso++;
                if (paso == (sizeof(anim10)/4))
                    nuevo_estado=_parado;
                
                if (paso == 4)
                {
                    sound(s_aire4,rand(50,75),256);
                    get_real_point(1,&golpe_x,&golpe_y);
                    new golpe(golpe_x,golpe_y,fuerza_golpe[3]);
                    if (fuerza_golpe[3]>2)
                        fuerza_golpe[3]--;
                }
            break;

            case _patada_aerea:     // Comprueba la patada area
                graph = anim11[paso];
                paso++;
                if (paso > 4)
                {
                    x+=inc_x;
                    y+=inc_y*3;
                    inc_y+=2;
                    if( y >= 440 )
                    {
                        y=440;
                        new polvo(x,y);
                        if (control(saltar, this))
                            nuevo_estado=_parado;
                        else
                            nuevo_estado=_agachandose;
                    }
                }
                if( (paso == 10) OR (paso == 19) )
                {
                    sound(s_aire5,rand(50,75),256);
                    get_real_point(1,&golpe_x,&golpe_y);
                    new golpe(golpe_x,golpe_y,fuerza_golpe[4]);
                    if (fuerza_golpe[4]>2)
                        fuerza_golpe[4]--;
                }
            break;

            case _tocado:   // Comprueba si el mueco ha sido tocado
                graph=anim12[paso];       // anima el grfico
                paso++;
                if (paso == (sizeof(anim12)/4) )   // Hasta que acabe
                {
                    // Haz un sonido al azar de los que tiene
                    switch(rand(0,3))
                    {
                        case 0:
                            sound(s_golpe1,rand(25,50),256);
                        break;
                        case 1:
                            sound(s_golpe2,rand(25,50),256);
                        break;
                        case 2:
                           sound(s_golpe3,rand(25,50),256);
                        break;
                    }
                    nuevo_estado=_parado;   // Cambia de estado
                    y=440;                  // Cae al suelo
                }
                x+=inc_x;      // Y mueve el mueco un poco
                // Si se movia el mueco, lo frena
                if (inc_x<0)   // Si se movia a la izquierda
                    inc_x++;   // Se frena
                
                if (inc_x>0)   // Si se movia a la derecha
                    inc_x--;   // Se frena
                
                if (y<440)     // Si estaba saltando
                    y+=8;      // Hace que baje
                
                if (y>=440)    // Si estaba por debajo del limite inferior
                    y=440;     // Lo coloca
                
            break;

            case _muerto:   // Comprueba si el mueco ha muerto
                if (paso == 0)
                 sound(s_muerto,25,256);     // Hace el sonido de cuando muere
                
                graph=anim13[paso];       // Anima el grfico hacia con una secuencia
                paso++;
                if (paso == (sizeof(anim13)/4))   // Y la deja parada
                    paso--;
                
                x+=inc_x;           // Mueve las coordenadas hasta cuadrarlas
                // Como el caso anterior (tocado) frena el mueco
                if (inc_x<0)
                    inc_x++;
                
                if (inc_x>0)
                    inc_x--;
                
                if (y<440)
                    y+=8;
                
                if (y>=440)
                    y=440;
                
            break;

        }

        if( estado != nuevo_estado )   // Actualiza el estado del mueco
        {
            estado=nuevo_estado;
            paso=nuevo_paso;        // Y el paso dentro de la animacin
            nuevo_paso=0;
        }

        if (x<60)                   // Comprueba que no se ha salido de pantalla
            x=60;                   // Y coloca el grfico si ha salido
        
        if (x>900)
            x=900;

        FRAME;
    }
END_BODY





//------------------------------------------------------------------------------
// Proceso golpe
// Maneja los golpes que lanzan los muecos
// Entradas: Coordenadas de donde se da realmente el golpe
//           'dao' Energa que quita al enemigo
//------------------------------------------------------------------------------

BEGIN_BODY( golpe )
    ctype=c_scroll;     // Introduce al proceso dentro del scroll
    z=-1;               // Lo pone por delante de los muecos
    graph=100;          // Elige el grfico de una bola para abarcar mas
    FRAME_PERCENT(0);
    // Comprueba si esta tocando a un mueco
    id_munecos = collision("muneco");
    if( id_munecos == father )      // Y que no sea l mismo que llamo a este proceso
        id_munecos = collision("muneco");  // Si es el mismo intenta coger el otro identificador

    if( id_munecos )              // Si ha tocado
    {
        // Hace un sonido al azar de los disponibles
        switch (rand(0,2))
        {
            case 0:
                sound(s_tocado1,rand(25,75),256);
            break;
            case 1:
                sound(s_tocado2,rand(25,75),256);
            break;
            case 2:
                sound(s_tocado3,rand(25,75),256);
            break;
        }
        ((muneco *)id_munecos)->paso=0;               // Actualiza la animacin del que ha sido tocado
        ((muneco *)id_munecos)->energia-=dano/2;      // Le quita energa
        
        if( ((muneco *)id_munecos)->energia <= 0 )       // Si no le queda energa
        {
            ((muneco *)id_munecos)->energia = 0;        // Es que esta muerto
            ((muneco *)id_munecos)->estado = _muerto;
            estado_juego=2;
        }else
            ((muneco *)id_munecos)->estado=_tocado;   // Si no, esta simplemente tocado
            
        if( id_munecos->flags )           // Mueve el grfico un poco para atrs
            ((muneco *)id_munecos)->inc_x=-8;
        else
            ((muneco *)id_munecos)->inc_x=8;
        
        switch(sangre)          // Crea la sangre
        {
            // Dependiendo del nivel elegido en las opciones
            case 0:     // Golpe sin sangre
                new golpe_sin_sangre(x,y);
            break;
            case 1:     // Golpe con sangre
                contador0 = (dano/3)+1;
                
                if(contador0 > 20) contador0 = 20;
                
                while( contador0 > 0 )
                {
                    new particula_sangre(x,y,((muneco *)id_munecos)->inc_x+rand(-2,2),rand(-4,0),rand(10,20));
                    contador0--;
                }
            break;
            case 2:    // Golpe con mucha sangre
                contador0 = dano+2;
                
                if(contador0 > 20) contador0 = 20;
                
                while( contador0 > 0 )
                {
                    new particula_sangre(x,y,(((muneco *)id_munecos)->inc_x*2)+rand(-4,4),rand(-8,2),rand(15,30));
                    contador0--;
                }
            break;    
        }
    }
END_BODY


MAIN_PROGRAM_CDIV

PRIVATE
    int
    codigo_mapa,    // Pantalla de fondo cargada en ese momento
    codigo_mapa2,
    contador0,      // Contador de uso general
    idtexto;
    
BEGIN_PROGRAM 
    //Definimos el modo grfico
    if( argc > 1 )
     set_gfx(GFX_AUTODETECT_WINDOWED);
    else
     set_gfx(GFX_AUTODETECT_FULLSCREEN);

    set_mode(m640x480);     // Selecciona modo de vdeo
    disable_key_escape();
    priority = -10;         // Pone muy poca prioridad
    FRAME;

    new intro();            // Ejecuta la intro del juego
    FRAME;                  // Necesario para parar este proceso
    
    LOOP // Bucle principal
    {
        fade_off(5);
        clear_screen();
        FRAME;
        
        set_fps(100);     // Numero de imgenes por segundo
        codigo_mapa = load_map("fostiato/menu.map");  // Carga la pantalla del men
        FRAME;
        
        fade_off(64);
        put_screen(1, codigo_mapa);  // Pone la pantalla del men
        FRAME;
        
        unload_map(codigo_mapa);    // Y la descarga de memoria para as tener mas

        fade_on(5);          // Enciende la pantalla
        FRAME;

        opcion = 0;           // Inicializa la variable de opciones

        while( opcion == 0)   // Bucle del men de presentacin
        {
            if( key(_1) OR key (_enter) ) 
             opcion=1;    // Juego
             
            if( key(_2) OR key (_esc) ) 
             opcion=2;    // Salir
            FRAME;
        }

        fade_off();             // Apaga la pantalla

        if( opcion==2 )          // Opcion elegida: Salir del juego
        {
            new creditos();         // Pone los crditos
            signal(this, s_kill);  // Elimina este proceso
            FRAME;                 // Y acaba.
        }

        clear_screen();
        FRAME;

        // Carga los grficos de la pantalla de opciones
        codigo_mapa = load_map("fostiato/opciones.map");
        FRAME;
        
        fade_off(64);
        FRAME;
        
        put_screen(1, codigo_mapa);  // Pone el grfico de fondo
        unload_map(codigo_mapa);    // Descarga el grfico de memoria

        opcion=0;                   // Inicializa la variable de opciones
        angulo_texto=0;             // Pone a cero el ngulo de desplazamiento del texto seleccionado
        
        // Pone los grficos de los muecos y del escenario elegidos
        id_luchador1 = new objetos(1,100,256,310+luchador1,1,0);
        id_luchador2 = new objetos(1,540,256,310+luchador2,0,0);
        id_auxiliar  = new objetos(1,320,300,300+escenario,0,0);
    
        muestra_informacion();  // Imprime todos los textos y grficos
        
        set_fps(32);     // Numero de imgenes por segundo
        
        
        fade_on(5);                  // Enciende la pantalla
        FRAME;

        LOOP{
            // Mueve el texto que este seleccionado en ese momento
            move_text(texto[opcion].codigo,texto[opcion].x+get_disty(angulo_texto,8),texto[opcion].y);
            opcion_anterior=opcion; // Guarda la opcin para no cambiar bruscamente

            // Lee las teclas
            if( key(_right) OR key(_down) )
                opcion++;
                
            if( key(_left) OR key(_up) )
                opcion--;

            // Se ha cambiado a otra opcin
            if( opcion != opcion_anterior )
            {
                // Espera a que se pare
                while( get_disty(angulo_texto,8) != 0 )
                {
                    angulo_texto += 22500;
                    move_text(texto[opcion_anterior].codigo,
                              texto[opcion_anterior].x+get_disty(angulo_texto,8),
                              texto[opcion_anterior].y);
                    FRAME;
                }

                // Normaliza las opciones
                if( opcion == 7  ) opcion = 0;
                if( opcion == -1 ) opcion = 6;

                // Espera a soltar la tecla
                while( key(_right) OR key(_down) OR key(_left) OR key(_up) )
                 FRAME;
            }else
                angulo_texto+=22500;    // Sigue moviendo el texto
            

            // Se ha elegido una opcin
            if( key(_enter) OR key(_space) OR key (_r_control) OR key(_l_control) )
            {
                // Empieza el juego
                if( opcion == 0 )
                 break;
                 
                switch( opcion )
                {
                    // Modo de juego (1/2 jugadores)
                    case 1:
                        modo++;
                        if( modo == 4 ) modo = 0; 
                    break;

                    // Nivel de juego (Fcil/Difcil)
                    case 2:
                        nivel++;
                        if( nivel == 3 ) nivel = 0;
                    break;

                    // Nivel de aparicin de sangre
                    case 3:
                        sangre++;
                        if( sangre == 3 ) sangre = 0;
                    break;

                    // Selecciona mueco del jugador 1
                    case 4:
                        luchador1++;
                        if( luchador1 == 4 ) luchador1 = 0;
                    break;

                    // Selecciona el escenario
                    case 5:
                        escenario++;
                        if( escenario == 3 ) escenario = 0;
                    break;

                    // Selecciona mueco del jugador 2
                    case 6:
                        luchador2++;
                        if( luchador2 == 4) luchador2 = 0;
                    break;
                }
                
                muestra_informacion();  // Actualiza la informacin de pantalla
                while( key(_enter) OR key(_space) OR key (_r_control) OR key(_l_control) ) // Espera a soltar la tecla
                    FRAME;
            }
            if( key(_esc) )    // Se ha pulsado 'escape'
            {
                esc_pulsado=1;// Pone variable a 1 la variable de escape pulsado
                break;        // Y sale del bucle
            }
            FRAME;
        }
        
        if( esc_pulsado )    // Sale del men de opciones si se pulso escape
        {
            esc_pulsado=0;  // Pone a a cero la variable para la proxima vez
            fade_off();     // Apaga la pantalla
            FRAME;
            let_me_alone(); // Deja unicamente el proceso principal(este)
            delete_text(all_text);//Borra cualquier texto que hubiera
            FRAME;
            continue;       // Sale del siguiente bucle
        }
        // Carga los grficos necesarios para el escenario elegido
        switch( escenario )
        {
            case 0:
                codigo_mapa  = load_map("fostiato/fondo1.map");
                codigo_mapa2 = load_map("fostiato/paisaje1.map");
            break;
            case 1:
                codigo_mapa  = load_map("fostiato/fondo2.map");
                codigo_mapa2 = load_map("fostiato/paisaje2.map");
                
            break;
            case 2:
                codigo_mapa  = load_map("fostiato/fondo3.map");
                codigo_mapa2 = load_map("fostiato/paisaje1.map");
            break;
        }
        

        // Carga los grficos necesarios para el jugador 1
        switch( luchador1 )
        {
            case 0: fpg_player1 = load_fpg("fostiato/mujer.fpg");    break;
            case 1: fpg_player1 = load_fpg("fostiato/hombre1.fpg");  break;
            case 2: fpg_player1 = load_fpg("fostiato/esquelet.fpg"); break;
            case 3: fpg_player1 = load_fpg("fostiato/hombre2.fpg");  break;
        }

        // Carga los grficos necesarios para el jugador 2
        switch( luchador2 )
        {
            case 0: fpg_player2 = load_fpg("fostiato/mujer.fpg");    break;
            case 1: fpg_player2 = load_fpg("fostiato/hombre1.fpg");  break;
            case 2: fpg_player2 = load_fpg("fostiato/esquelet.fpg"); break;
            case 3: fpg_player2 = load_fpg("fostiato/hombre2.fpg");  break;
        }

        // Si los jugadores son iguales convierte uno de ellos a grises
        if( luchador1 == luchador2 )
        {
            for( contador0 = 1; contador0 <= 54; contador0++)
                // Cambia los 54 primeros grficos del fichero
                // a la paleta de grises
                convert_palette(2, contador0, grises);
            
            convert_palette(2, 100, grises);// Tambin convierte los grficos
            convert_palette(2, 101, grises);// pequeos de las carras
        }

        combates1=0;    // Inicializa las variables del juego
        combates2=0;
        sangre_total=0;
        
        do          // Bucle del juego
        {

            fade_off(); // Apaga la pantalla
            FRAME;

            // Borra los textos, procesos  o 'scrolles' que hubiera abiertos
            let_me_alone();
            delete_text(all_text);
            stop_scroll(0);
            clear_screen();

            // Selecciona el numero de pantallas por segundo y el tipo de restauracin
            set_fps(100);

            // Pone la pantalla a blanco
            fade(255, 255, 255, 16);
            FRAME;

            estado_juego=0; // Para el juego para poner todo

            // Inicializa el scroll
            start_scroll(0, 0, codigo_mapa2, codigo_mapa, 0, 0);
            scroll[0].x1 = 160;

            // Crea los muecos  que se han seleccionado
            // y el tipo de control de los mismos
            switch( modo )
            {
                // Ordenador contra ordenador
                case 0:
                    id_luchador1 = new muneco(260,440,fpg_player1,1,control_ordenador,luchador1);
                    id_luchador2 = new muneco(700,440,fpg_player2,0,control_ordenador,luchador2);
                break;

                // Jugador contra ordenador
                case 1:
                    id_luchador1 = new muneco(260,440,fpg_player1,1,control_teclado1,luchador1);
                    id_luchador2 = new muneco(700,440,fpg_player2,0,control_ordenador,luchador2);
                break;

                // Ordenador contra jugador
                case 2:
                    id_luchador1 = new muneco(260,440,fpg_player1,1,control_teclado2,luchador1);
                    id_luchador2 = new muneco(700,440,fpg_player2,0,control_ordenador,luchador2);
                break;

                // Jugador contra jugador
                case 3:
                    id_luchador1 = new muneco(260,440,fpg_player1,1,control_teclado2,luchador1);
                    id_luchador2 = new muneco(700,440,fpg_player2,0,control_teclado1,luchador2);
                break;
            }

            // Inicializa las variables enemigo de los muecos que son
            // identificadores al proceso del enemigo
            ((muneco *)id_luchador1)->enemigo = (muneco *)id_luchador2;
            ((muneco *)id_luchador2)->enemigo = (muneco *)id_luchador1;

            new objetos(fpg_game,194,38,201,0,1);
            new objetos(fpg_game,446,38,202,0,2);
            new objetos(fpg_game,320,49,200,0,0); // Pone los marcadores de energa

            define_region(1,0,0,640,480);   // Define las regiones para el movimiento
            define_region(2,0,0,640,480);   // de pantalla

            // Escribe el nombre del escenario
            write(1,320,0,1,escenarios[escenario]);

            // Pone las fotos y los nombres de los muecos
            new objetos(id_luchador1->file,44,52,100+combates2,1,0);
            write(1,45,100,1,nombres[luchador1]);
            new objetos(id_luchador2->file,596,52,100+combates1,0,0);
            write(1,596,100,1,nombres[luchador2]);

            // Crea las estrellas que marcan los combates ganados
            crea_estrellas();

            // Pone el mensaje de inicio de combate
            switch( combates1+combates2 )
            {
                case 0:
                    idtexto = write(2,320,200,4,"ASALTO 1");
                break;
                case 1:
                    idtexto = write(2,320,200,4,"ASALTO 2");
                break;
                case 2:
                    idtexto = write(2,320,200,4,"ASALTO 3");
                break;
            }
            FRAME;

            unfade(16);       // Muestra la pantalla
            FRAME;

            // Dependiendo del nivel el juego va mas o menos rpido
            set_fps(default_fps + (nivel * 2));
            FRAME_PERCENT(4800);    // Hace una pequea pausa

            // Borra el texto de inicio de combate
            delete_text(idtexto);

            estado_juego=1;             // Quita la pausa al juego
            
            do  // Bucle de cada combate
            {
                // Coloca el scroll dependiendo de las posiciones de los luchadores
                scroll[0].x1 = (id_luchador1->x+id_luchador2->x) / 6;
                FRAME;

                // Actualiza los marcadores
                define_region(1,296-((muneco *)id_luchador1)->energia,28,((muneco *)id_luchador1)->energia+1,20);
                define_region(2,345,29,((muneco *)id_luchador2)->energia+1,20);

                // Comprueba si se ha pulsado 'escape'
                if (key(_esc)) esc_pulsado=1;

            // Repite hasta que se pulse escape o gane algun luchador
            }while( !((estado_juego==2) OR esc_pulsado));

            // Si no se ha pulsado escape es que alguno ha ganada
            if( !esc_pulsado )
            {
                if( ((muneco *)id_luchador1)->energia == 0 ) // Gana el jugador 2
                    combates2++;
                else
                    combates1++;            // Gana el jugador 1
                    
                crea_estrellas();   // Actualiza las estrellas
                FRAME_PERCENT(4800);
            }

        // Repite hasta que algun jugador gane dos combates
        }while( (combates1 != 2) AND (combates2 != 2) AND !esc_pulsado );

        // Si no se ha pulsado 'escape' pon el final de la lucha
        if( NOT esc_pulsado )
        {
            // Pon el numero de imgenes por segundo como en el men
            set_fps(100);

            fade(255,255,255,16);       // Pone la pantalla a blanco
            FRAME;

            // Pone el nombre del que ha ganado
            if( combates1 == 2 )
                write(2,320,160,4,nombres[luchador1]);
            else
                write(2,320,160,4,nombres[luchador2]);

            // Y el mensaje de gana
            write(2,320,220,4,"GANA");

            unfade(16);       // Enciende pantalla
            FRAME;

            // Pone el numero de imgenes por segundo como en el juego
            set_fps(default_fps + (nivel*2));

            FRAME_PERCENT(9600);                // Espera un rato

        }else
            // Actualiza la variable que guarda la pulsacin de 'escape'
            esc_pulsado=0;

        fade_off(); // Apaga la pantalla
        FRAME;

        // Inicializa todo, borra procesos, textos pendientes, scrolles, etc
        stop_scroll(0);             // Para scroll
        unload_fpg(fpg_player1);              // Descarga ficheros de grficos
        unload_fpg(fpg_player2);
        unload_map(codigo_mapa);    // Descarga mapas grficos
        unload_map(codigo_mapa2);
        let_me_alone();             // Borra procesos
        delete_text(all_text);      // Borra textos
        id_luchador1 = id_luchador2 = id_auxiliar = NULL;
    }


END_PROGRAM
